Imports Microsoft.VisualBasic
Imports System
Imports System.IO
Imports System.Threading
Imports System.Collections.Generic
Imports System.Reflection

'INSTANT VB TODO TASK: There is no equivalent to #pragma directives in VB.NET:
'#pragma warning disable 0618

Namespace System.Threading

	Public Class MyMonitor

		Private ReadOnly Shared CoverTag As String = "CC_COVER_TAG_CC"

		Private Const ByteSize As Integer = 1024*1024\2 ' Lets use 1M total.
		Private Shared mHitCount(ByteSize / Len(New Long) - 1) As Long
		Private Shared mContentCount(ByteSize / Len(New Long) - 1) As Long
		Private Shared sFoo As New MyMonitor()

		Private Shared sTime As DateTime = DateTime.Now

		Public Shared Function GetCoverFile() As String
			Return "cc.cov." & CoverTag & "." & Environment.MachineName & ".txt"
		End Function

		Protected Overrides Sub Finalize()
			Try
				Dump(GetCoverFile())
			Catch e As Exception
				Console.Error.WriteLine("~MyMonitor:Catch(" & e.Message & ")")
				Console.Error.WriteLine(e)
			End Try
		End Sub

		Public Shared Sub Clear()
			For i As Integer = 0 To mHitCount.Length - 1
				mContentCount(i) = 0
				mHitCount(i) = mContentCount(i)
			Next i
		End Sub

		Public Shared Function GetCoverTag() As String
			Return CoverTag
		End Function

		Public Shared Function GetContendCount(ByVal syncId As Integer) As Long
			Return mContentCount(syncId)
		End Function

		Public Shared Function GetHitCount(ByVal syncId As Integer) As Long
			Return mHitCount(syncId)
		End Function

		Public Shared Sub MarkPoint(ByVal syncId As Integer, ByVal didWait As Boolean)
			If didWait Then
				Interlocked.Increment(mContentCount(syncId))
			Else
				Interlocked.Increment(mHitCount(syncId))
			End If
		End Sub

		Public Shared Sub Enter(ByVal obj As Object, ByVal id As Integer)
			Dim didAquire As Boolean = False
			MyMonitor.Enter(obj, didAquire, id)
		End Sub

		Public Shared Sub Enter(ByVal obj As Object, ByRef didAquire As Boolean, ByVal id As Integer)
			didAquire = Monitor.TryEnter(obj)
			If didAquire Then
				MarkPoint(id, False)
			Else
				Monitor.Enter(obj)
				didAquire = True
				MarkPoint(id, True)
			End If
		End Sub

		Public Shared Sub Dump(ByVal file As String)
			Using w As New StreamWriter(file, True)
				w.WriteLine("~|B3|~")
				w.WriteLine("A|" & System.Reflection.Assembly.GetEntryAssembly().Location)
				w.WriteLine("C|" & Environment.CommandLine)
				w.WriteLine("D|" & sTime.ToString("yyyyMMdd`HHmmss"))
				w.WriteLine("T|" & CoverTag)
				w.WriteLine("M|" & Environment.MachineName)
                w.WriteLine("O|" & Environment.OSVersion.ToString())
				w.WriteLine("P|" & Environment.ProcessorCount)
				w.WriteLine("SP|")

				For i As Integer = 0 To mHitCount.Length - 1
					If mHitCount(i) <> 0 OrElse mContentCount(i) <> 0 Then
						w.WriteLine(i + AscW("|" )+ mHitCount(i) & "|" & mContentCount(i))
					End If
				Next i

				w.WriteLine("~|E|~")
			End Using
		End Sub

	End Class ' class

End Namespace ' namespace
