Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Diagnostics

Friend Class ProcessUtil

	Public Shared Function StartAndWaitForResult(ByVal fileName As String, ByVal arguments As String, <System.Runtime.InteropServices.Out()> ByRef stdOut As String, <System.Runtime.InteropServices.Out()> ByRef stdErr As String) As Integer
		Dim info As New ProcessStartInfo(fileName, arguments)
		info.UseShellExecute = False
		info.ErrorDialog = False
		info.CreateNoWindow = True
		info.RedirectStandardOutput = True
		info.RedirectStandardError = True

		stdOut = String.Empty
		stdErr = String.Empty

        Dim outputDataReceivedClosure As New OutputDataReceivedClosure With {.o = New StringBuilder()}
        Dim errorDataReceivedClosure As New ErrorDataReceivedClosure With {.err = New StringBuilder()}

		Using p As Process = Process.Start(info)

            AddHandler p.OutputDataReceived, AddressOf outputDataReceivedClosure.OnOutputDataReceived
            AddHandler p.ErrorDataReceived, AddressOf errorDataReceivedClosure.OnErrorDataReceived

			p.BeginErrorReadLine()
			p.BeginOutputReadLine()

			p.WaitForExit()

			Console.WriteLine()

            stdOut = outputDataReceivedClosure.o.ToString()
            stdErr = errorDataReceivedClosure.err.ToString()

			Return p.ExitCode
		End Using
	End Function

    Private Class OutputDataReceivedClosure
        Public o As StringBuilder

        Public Sub OnOutputDataReceived(ByVal sender As Object, ByVal e As DataReceivedEventArgs)
            If e.Data IsNot Nothing Then
                o.AppendLine(e.Data)
                Console.Write(".")
            End If
        End Sub
    End Class

    Private Class ErrorDataReceivedClosure
        Public err As StringBuilder

        Public Sub OnErrorDataReceived(ByVal sender As Object, ByVal e As DataReceivedEventArgs)
            If e.Data IsNot Nothing Then
                err.AppendLine(e.Data)
                Console.Write("!")
            End If
        End Sub

    End Class
    
End Class ' class
