Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Collections.ObjectModel
Imports System.IO
Imports System.Windows.Data

Namespace SyncView

	Public Class SourceCodeConverter
		Implements IValueConverter

		Private mData As Dictionary(Of String, ObservableCollection(Of LineInfo)) = New Dictionary(Of String, ObservableCollection(Of LineInfo))()

		Public Function Convert(ByVal value As Object, ByVal targetType As System.Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.Convert
			Dim c As ObservableCollection(Of LineInfo)
			If (Not mData.TryGetValue(CStr(value), c)) Then
				c = New ObservableCollection(Of LineInfo)(New List(Of LineInfo)(ReadFile(CStr(value))))
				mData(CStr(value)) = c
			End If

			Return c
		End Function

		Private Function ReadFile(ByVal fileName As String) As IEnumerable(Of LineInfo)
			Dim lines As List(Of LineInfo) = New List(Of LineInfo)(File.ReadAllLines(fileName).Select(Function(x, i) New LineInfo() With {.Text = x, .LineNumber = i + 1, .Priority = 0}))

			Dim cm As IEnumerable(Of CoverMapRow) = CoverMap.FromFile(Window1.MapFile)
			Dim coverData As IEnumerable(Of CoverRun) = CoverRun.FromFile(Window1.CoverFile)

			Dim coverage = coverData.SelectMany(Function(cov) cov.Data)

			Dim cd = cm.Where(Function(x) x.FileName = fileName).Select(Function(syncpoint) New With {Key .SyncID = syncpoint.SyncId, Key .Line = syncpoint.LineNumber, Key .Entered = coverage.Where(Function(cov) cov.SyncId = syncpoint.SyncId).Select(Function(cov) cov.WasEntered).Contains(True), Key .Waited = coverage.Where(Function(cov) cov.SyncId = syncpoint.SyncId).Select(Function(cov) cov.DidWait).Contains(True)})

			For Each x In cd
				lines(x.Line - 1).SyncId = x.SyncID
				If x.Waited Then
					lines(x.Line - 1).Priority = 1
				ElseIf x.Entered Then
					lines(x.Line - 1).Priority = 2
				Else
					lines(x.Line - 1).Priority = 3
				End If
			Next x

			Return lines
		End Function

		Public Function ConvertBack(ByVal value As Object, ByVal targetType As System.Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
			Throw New System.NotImplementedException()
		End Function

	End Class ' class

End Namespace ' namespace

